jv.geom

## Class PgFaceStar

- java.lang.Object
- - jv.vecmath.P_Vector
  - - jv.vecmath.PiVector
    - - jv.geom.PgFaceStar

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Cloneable

      public final class PgFaceStar
      extends PiVector

  Face of an volume set with number of adjacent volume elements, indices to adjacent volume elements and local index of the face in each volume element.

  There may be more than two volume elements joining a face.

  Note, when superclass has changed to PiVector then method this#getSize() has been renamed to this#getValence() to avoid conflict PiVector#getSize().

  See Also:
    Serialized Form
  Author:
    Konrad Polthier
  Version:
    09.03.15, 4.00 revised (kp) Moved to jv.geom from dev.volume.
    08.02.11, 3.10 revised (ur) Change int arrays to PiVectors, correct comments. 02.07.06, 3.00 revised (kp) Superclass changed to PiVector to allow usage as PiVector [] array.
    Note, method this#getSize() renamed to this#getValence() since conflict with superclass.
    23.12.01, 2.10 revised (ep) Internationalization.
    23.06.00, 2.00 revised (kp) Superclass changed to P_Vector to allow tagging.
    02.04.00, 1.20 revised (kp) Allocate array of 2 during construction to avoid reallocation.
    03.09.99, 1.10 revised (kp) Former inner class of PgElementSet converted to public class.
    00.00.98, 1.00 created (kp)

- - ### Field Summary

    - ### Fields inherited from class jv.vecmath.PiVector

      `m_data`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `PgFaceStar()` Create a new face.
    `PgFaceStar(int v1, int v2, int v3)` Create a new face with given vertex indices, and valence zero.
    `PgFaceStar(int v1, int v2, int v3, int v4)` Create a new face with given vertex indices, and valence zero.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addElement(int elemInd, int locNeighInd)` Add another volume element and the local index of its vertex opposite to the face.
    `java.lang.Object` | `clone()` Clone object and all instance variables.
    `void` | `copy(PiVector object)` Copy instance variables by duplication, not by copying a reference.
    `PiVector` | `getElementInd()` Get array with indices of adjacent volume elements.
    `int` | `getElementInd(int ind)` Get index of volume element at position 'ind'.
    `PiVector` | `getNeighbourLocInd()` Get array containing the local index of neighbour vertex of all volume elements.
    `int` | `getNeighbourLocInd(int ind)` Get local index of neighbour vertex of volume element at position 'ind'.
    `int` | `getValence()` Get current number of adjacent volume elements sharing this face.
    `int` | `getVertexInd(int ind)` Get index of i-th vertex of face.
    `void` | `setElementInd(int ind, int elemInd)` Set index of volume element at valence position 'ind' within 0 and current valence.
    `void` | `setNeighbourLocInd(int ind, int locNeighInd)` Set local index of adjacent volume element at valence position 'ind' within 0 and current valence.
    `void` | `setValence(int val)` Set currently number of adjacent volume elements sharing this face.
    `java.lang.String` | `toString()` Create a multi-line string representation with detailed information about all instance variables.

    - ### Methods inherited from class jv.vecmath.PiVector

      `add, add, add, add, addEntry, adjustSizes, alloc, average, blend, blend, blendBase, blendNew, changeValue, changeValue, concat, concatNew, contains, copy, copy, copy, copyArray, copyNew, copyNew, copyNew, copyNew, dist, dot, dot, equals, equals, equals, getEntries, getEntries, getEntry, getFirstEntry, getIndexOf, getLastEntry, getLength, getSameSize, getSize, hasUniqueEntries, indexOfAbsMax, indexOfAbsMin, indexOfMax, indexOfMin, indexOfValueInOrdering, invert, invert, leftMultMatrix, leftMultMatrix, length, max, max, maxAbs, min, min, multScalar, multScalar, normalize, normalize, realloc, realloc, removeEntry, removeSuccessiveDuplicates, rightMultMatrix, rightMultMatrix, set, set, set, set, set, set, set, set, setConstant, setConstant, setConstant, setConstant, setConstant, setEntry, setFirstEntry, setLastEntry, setLength, setSize, shift, sort, sort, sqrDist, sqrLength, sub, sub, subNew, sum, toShortString`

    - ### Methods inherited from class jv.vecmath.P_Vector

      `clearTag, clone, clone, copy, getBits, getDetail, getName, getURL, hasTag, invert, setDetail, setName, setTag, setURL`

    - ### Methods inherited from class java.lang.Object

      `getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### PgFaceStar

          public PgFaceStar()

      Create a new face.

    - #### PgFaceStar

          public PgFaceStar(int v1,
                            int v2,
                            int v3)

      Create a new face with given vertex indices, and valence zero.

    - #### PgFaceStar

          public PgFaceStar(int v1,
                            int v2,
                            int v3,
                            int v4)

      Create a new face with given vertex indices, and valence zero.

  - ### Method Detail

    - #### copy

          public void copy(PiVector object)

      Copy instance variables by duplication, not by copying a reference.
      Overrides:
        `copy` in class `PiVector`
      Parameters:
        `object` - source vector to copy
      Since:
        JavaView 3.96.031
      See Also:
        `clone()`
      Version:
        08.07.06, 1.00 created (kp)

    - #### clone

          public java.lang.Object clone()

      Clone object and all instance variables.
      Overrides:
        `clone` in class `PiVector`
      Since:
        JavaView 3.96.031
      See Also:
        `copy(PiVector)`
      Version:
        08.07.06, 1.00 created (kp)

    - #### toString

          public java.lang.String toString()

      Create a multi-line string representation with detailed information about all instance variables.
      Overrides:
        `toString` in class `PiVector`
      See Also:
        `PiVector.toShortString()`

    - #### getValence

          public int getValence()

      Get current number of adjacent volume elements sharing this face.
      Since:
        JavaView 3.96.026, replaces original method getSize() since conflict with PiVector#getSize().

    - #### setValence

          public void setValence(int val)

      Set currently number of adjacent volume elements sharing this face.
      Since:
        JavaView 3.96.026

    - #### addElement

          public void addElement(int elemInd,
                                 int locNeighInd)

      Add another volume element and the local index of its vertex opposite to the face. Valence if this edge is incremented by one.

    - #### getVertexInd

          public int getVertexInd(int ind)

      Get index of i-th vertex of face.
      Parameters:
        `ind` - local index vertex in this face
      Returns:
        index of edge vertex within [0,numVertices-1], where numVertices refers to a volume set.
      Since:
        JavaView 3.96.026

    - #### getElementInd

          public PiVector getElementInd()

      Get array with indices of adjacent volume elements.

    - #### getElementInd

          public int getElementInd(int ind)

      Get index of volume element at position 'ind'.

    - #### setElementInd

          public void setElementInd(int ind,
                                    int elemInd)

      Set index of volume element at valence position 'ind' within 0 and current valence.

    - #### getNeighbourLocInd

          public PiVector getNeighbourLocInd()

      Get array containing the local index of neighbour vertex of all volume elements.

    - #### getNeighbourLocInd

          public int getNeighbourLocInd(int ind)

      Get local index of neighbour vertex of volume element at position 'ind'.

    - #### setNeighbourLocInd

          public void setNeighbourLocInd(int ind,
                                         int locNeighInd)

      Set local index of adjacent volume element at valence position 'ind' within 0 and current valence.

"

The software JavaView? is copyright protected. All Rights Reserved.
"